package pps.core.prediction.service.data.energy_consumption_analysis;

import jakarta.validation.constraints.NotBlank;
import jakarta.validation.constraints.NotNull;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;
import xstartup.annotation.XText;

import java.util.Date;

/**
 * 能耗分析(模拟数据测试用)
 *
 * @author ZWT
 * @date 2023/09/20
 */
@Data
@NoArgsConstructor
@AllArgsConstructor
@Builder
public class GetEnergyConsumptionAnalysisInput {

    @XText("组织机构ID")
    @NotBlank(message = "缺少组织机构ID")
    private String ouId;

    @NotNull(message = "缺少日期类型")
    @XText("日期类型(0_今日,1_近7天,2_近30天,3_自定义)")
    private Integer dateType;

    @XText("自定义开始时间")
    private Date startTime;

    @XText("自定义结束时间")
    private Date endTime;
}
